<script>
import { GlAlert, GlButton, GlIcon, GlSprintf } from '@gitlab/ui';
import { joinPaths } from '~/lib/utils/url_utility';
import { s__ } from '~/locale';
import glFeatureFlagMixin from '~/vue_shared/mixins/gl_feature_flags_mixin';
import { NEW_POLICY_BUTTON_TEXT } from '../constants';
import ApprovalPolicyNameUpdateBanner from './banners/approval_policy_name_update_banner.vue';
import BreakingChangesBanner from './banners/breaking_changes_banner.vue';
import ExperimentFeaturesBanner from './banners/experiment_features_banner.vue';
import ProjectModal from './project_modal.vue';

export default {
  BANNER_STORAGE_KEY: 'security_policies_scan_result_name_change',
  components: {
    ApprovalPolicyNameUpdateBanner,
    BreakingChangesBanner,
    ExperimentFeaturesBanner,
    GlAlert,
    GlButton,
    GlIcon,
    GlSprintf,
    ProjectModal,
  },
  mixins: [glFeatureFlagMixin()],
  inject: [
    'assignedPolicyProject',
    'disableSecurityPolicyProject',
    'disableScanPolicyUpdate',
    'documentationPath',
    'newPolicyPath',
  ],
  i18n: {
    title: s__('SecurityOrchestration|Policies'),
    subtitle: s__(
      'SecurityOrchestration|Enforce %{linkStart}security policies%{linkEnd} for this project.',
    ),
    newPolicyButtonText: NEW_POLICY_BUTTON_TEXT,
    editPolicyProjectButtonText: s__('SecurityOrchestration|Edit policy project'),
    viewPolicyProjectButtonText: s__('SecurityOrchestration|View policy project'),
  },
  data() {
    return {
      projectIsBeingLinked: false,
      showAlert: false,
      alertVariant: '',
      alertText: '',
      modalVisible: false,
      approvalPolicyNameBannerVisible: false,
    };
  },
  computed: {
    approvalPolicyNameBannerEnabled() {
      return this.approvalPolicyNameBannerVisible || !this.breakingChangesBannerEnabled;
    },
    feedbackBannerEnabled() {
      return (
        this.glFeatures.securityPoliciesPolicyScope || this.glFeatures.compliancePipelineInPolicies
      );
    },
    breakingChangesBannerEnabled() {
      return this.glFeatures.securityPoliciesBreakingChanges;
    },
    hasAssignedPolicyProject() {
      return Boolean(this.assignedPolicyProject?.id);
    },
    securityPolicyProjectPath() {
      return joinPaths('/', this.assignedPolicyProject?.full_path);
    },
  },
  methods: {
    updateAlertText({ text, variant, hasPolicyProject }) {
      this.projectIsBeingLinked = false;

      if (text) {
        this.showAlert = true;
        this.alertVariant = variant;
        this.alertText = text;
      }
      this.$emit('update-policy-list', { hasPolicyProject, shouldUpdatePolicyList: true });
    },
    isUpdatingProject() {
      this.projectIsBeingLinked = true;
      this.showAlert = false;
      this.alertVariant = '';
      this.alertText = '';
    },
    dismissAlert() {
      this.showAlert = false;
    },
    showNewPolicyModal() {
      this.modalVisible = true;
    },
    showApprovalPolicyBanner(hideBreakingChangesBanner) {
      this.approvalPolicyNameBannerVisible = hideBreakingChangesBanner;
    },
  },
};
</script>
<template>
  <div>
    <gl-alert
      v-if="showAlert"
      class="gl-mt-3"
      :dismissible="true"
      :variant="alertVariant"
      data-testid="error-alert"
      @dismiss="dismissAlert"
    >
      {{ alertText }}
    </gl-alert>
    <header class="gl-my-6 gl-display-flex gl-flex-direction-column">
      <div class="gl-display-flex gl-align-items-flex-start">
        <div class="gl-flex-grow-1 gl-my-0">
          <h2 class="gl-mt-0">
            {{ $options.i18n.title }}
          </h2>
          <p data-testid="policies-subheader">
            <gl-sprintf :message="$options.i18n.subtitle">
              <template #link="{ content }">
                <gl-button
                  class="gl-pb-1!"
                  variant="link"
                  :href="documentationPath"
                  target="_blank"
                >
                  {{ content }}
                </gl-button>
              </template>
            </gl-sprintf>
          </p>
        </div>
        <gl-button
          v-if="!disableSecurityPolicyProject"
          data-testid="edit-project-policy-button"
          class="gl-mr-4"
          :loading="projectIsBeingLinked"
          @click="showNewPolicyModal"
        >
          {{ $options.i18n.editPolicyProjectButtonText }}
        </gl-button>
        <gl-button
          v-else-if="hasAssignedPolicyProject"
          data-testid="view-project-policy-button"
          class="gl-mr-3"
          target="_blank"
          :href="securityPolicyProjectPath"
        >
          <gl-icon name="external-link" />
          {{ $options.i18n.viewPolicyProjectButtonText }}
        </gl-button>
        <gl-button
          v-if="!disableScanPolicyUpdate"
          data-testid="new-policy-button"
          variant="confirm"
          :href="newPolicyPath"
        >
          {{ $options.i18n.newPolicyButtonText }}
        </gl-button>
      </div>

      <experiment-features-banner v-if="feedbackBannerEnabled" />

      <project-modal
        :visible="modalVisible"
        @close="modalVisible = false"
        @project-updated="updateAlertText"
        @updating-project="isUpdatingProject"
      />
    </header>

    <approval-policy-name-update-banner v-if="approvalPolicyNameBannerEnabled" class="gl-my-3" />

    <breaking-changes-banner
      v-if="breakingChangesBannerEnabled"
      class="gl-mt-3 gl-mb-6"
      @dismiss="showApprovalPolicyBanner"
    />
  </div>
</template>
